function Dp = control_quasistatic(th, p, thDes, Fr)
global boomParams dt
if nargin < 4
    Fr = [0,0]';
end

matSys = getMat_quasistatic(th, p, boomParams.M, boomParams.L, [boomParams.Cs boomParams.Cv]);
matSys_DthFr = matSys(:,[1:boomParams.n, end-1,end]);
matSys_Dth = matSys(:,[1:boomParams.n]);
matSys_Dp = matSys(:,[(boomParams.n+1):(boomParams.n+4)]);
matSys_DpFr = matSys(:,[(boomParams.n+1):(boomParams.n+6)]);

gainMat = 0.1 * eye(boomParams.n);

TargetDth = gainMat*(thDes - th);
%Dp = pinv(matSys_Dp) * (-matSys_DthFr*[TargetDth;Fr]); % use Moore Pensore inverse
DpFr = inv(matSys_DpFr) * (-matSys_Dth*[TargetDth]);
Dp = DpFr(1:4);
%DpNorm = sqrt(sum(Dp.^2)/2);
%Dp = Dp / max([1, DpNorm]);
