function f = ForceProfile(t)

tauL = 0;
LforceAngle = (pi/2)*0.5*(1-erf((t-20)*0.2)) + pi/8;
LforceMag = 0.5;
forceLX = LforceMag*cos(LforceAngle); %-0.5; %
forceLY = LforceMag*sin(LforceAngle); %1.0; %

tauR = 0;
RforceAngle = (pi/2)*0.5*(1-erf((t-20)*0.5)) - pi/8;
RforceMag = 0.5 * (1 - exp(-((t-16)*0.8)^2));
forceRX = RforceMag*cos(RforceAngle); %0.5; %
forceRY = RforceMag*sin(RforceAngle); %1.0; %

f = [ tauL, forceLX, forceLY, tauR, forceRX, forceRY ]';


% ===========================
% Forces

%{
function ret = tauL(t)
ret = 0;

function ret = forceLX(t)
ret = -0.1;
if t>=10 && t<=20
    ret = ret + 0.04*(t-10);
end

function ret = forceLY(t)
ret = 0.2;
if t>=10 && t<=20
    ret = ret - 0.04*(t-10);
end

function ret = tauR(t)
ret = 0;

function ret = forceRX(t)
ret = 0.1;
if t>=10 && t<=20
    ret = ret + 0.02*(t-10);
end

function ret = forceRY(t)
ret = 0.2;

%}
