function dv = boomODEs(t,v)
% v = [xL,yL,th1,th2,...,thn, DxL,DyL,Dth1,Dth2,...,Dthn]
% dv = [DxL,DyL,Dth1,Dth2,...,Dthn, DDxL,DDyL,DDth1,DDth2,...,DDthn]
global boomParams

f = ForceProfile(t);
[mainMat, mainVec] = getDs(v, f, boomParams.M, boomParams.L, [boomParams.Cs, boomParams.Cv]);

np2x2 = length(v);
np2 = np2x2 / 2;

dv = [ v(np2+1:end) ; inv(mainMat)*mainVec ];

