function dv = boomODEs(t,v)
% v = [th1,th2,...,thn, Dth1,Dth2,...,Dthn]
% dv = [Dth1,Dth2,...,Dthn, DDth1,DDth2,...,DDthn]
global boomParams ForceSols

endPos = EndTraj(t);
[mainMat, mainVec] = getDs(v, endPos, boomParams.M, boomParams.L, [boomParams.Cs, boomParams.Cv]);
force_acc_vec = inv(mainMat)*mainVec;
if(isempty(ForceSols))
    ForceSols.t = [];
    ForceSols.f = [];
end
ForceSols.t(end+1) = t;
ForceSols.f(end+1,:) = force_acc_vec(1:4)';

nx2 = length(v);
n = nx2 / 2;

dv = [ v(n+1:end) ; force_acc_vec(5:end) ];

